//-----------------------------------------------------------------
//
// Title       : MUX
// Design      : decoder_5bit
// Author      : Sindre
// File        : MUX.v
//
//-----------------------------------------------------------------
//
// Description : 2 input 1 output Multiplexor
//
//-----------------------------------------------------------------
`timescale 1 ns / 1 ps

//{module {MUX}}
module MUX #(parameter width=5'b00101) (in1, in2, sel, out1);
	input [width-1:0] in1;
	input [width-1:0] in2;
	input sel;
	
	wire [width-1:0] in1;
	wire [width-1:0] in2;
	wire sel;
	
	output [width-1:0] out1;
	
	reg [width-1:0] out1;
	
	always @(in1 or in2 or sel)
	begin
		if(sel)
			out1 = in2;
		else
			out1 = in1;
	end
endmodule
