//-----------------------------------------------------------------------------
//
// Title       : Codeword_Store
// Design      : decoder_5bit
// Author      : Sindre
// File        : Codeword_Store.v
//
//-----------------------------------------------------------------------------
//
// Description : Module for storing codeword
//
//-----------------------------------------------------------------------------
`timescale 1 ns / 1 ps

//{module {Codeword_Store}}
module Codeword_Store #(parameter width=5)(
	input clk,						  //clock signal
	input we,						  //write enable
	input re,						  //read enable
	input [width-1:0] address_write,  //write address
	input [width-1:0] address_read,	  //read address
	input [width-1:0] data_in,		  //data input
	output reg [width-1:0] data_out	  //data output
	);
	
	reg [width-1:0] mem [0:30];
	reg [4:0] i;
	
	initial
	begin
		for(i=0; i<31; i=i+1)
			mem[i] = 0; 
	end
	
	always @(posedge clk)
	begin
		if(we == 1'b1)begin
			mem[address_write] <= data_in;
		end
		
		if(re == 1'b1)begin
			data_out <= mem[address_read];
		end
	end

endmodule
