//-----------------------------------------------------------------------------
//
// Title       : D_reg
// Design      : decoder_5bit
// Author      : Sindre
// File        : D_reg.v
//
//-----------------------------------------------------------------------------
//
// Description : D-register
//
//-----------------------------------------------------------------------------
`timescale 1 ns / 1 ps


//{module {D_reg}}
module D_reg #(parameter width=5) (clk, reset, enable, d_in, d_out);
	
input clk;
input reset;
input enable;
input [width-1:0] d_in;

wire clk;
wire reset;
wire [width-1:0] d_in;

output [width-1:0] d_out;
reg [width-1:0] d_out;

always @ (posedge clk or negedge reset)
begin
	if(!reset)begin
		d_out <= 4'b0000;
	end else if(enable)begin 
		d_out <= d_in;
	end
end	
endmodule