//-----------------------------------------------------------------------------
//
// Title       : Full_mult
// Design      : decoder_5bit
// Author      : Sindre
// File        : Full_mult.v
//
//-----------------------------------------------------------------------------
//
// Description : Full multiplier for GF(32), 5 bit multiplication Y=A*B
//				 With primitive polynomial x^5+x^2+1 => 37 decimal
//
//-----------------------------------------------------------------------------
`timescale 1 ns / 1 ps

//{module {Full_mult}}
module Full_mult #(parameter width=5'b00101) (A , B, Y);
input [width-1:0] A; 	//5 bit input
input [width-1:0] B; 	//5 bit input
output [width-1:0] Y;	//5 bit output

wire [width-1:0] A;
wire [width-1:0] B;
wire [width-1:0] Y;
									   							  
assign Y[4] = (A[0] & B[4]) ^ (A[1] & B[3]) ^ (A[2] & B[2]) ^ (A[3] & B[1]) ^ (A[4] & B[0]) ^ (A[3] & B[4]) ^ (A[4] & B[3]);
assign Y[3] = (A[0] & B[3]) ^ (A[1] & B[2]) ^ (A[2] & B[1]) ^ (A[3] & B[0]) ^ (A[2] & B[4]) ^ (A[3] & B[3]) ^ (A[4] & B[2]) ^ (A[4] & B[4]);
assign Y[2] = (A[0] & B[2]) ^ (A[1] & B[1]) ^ (A[2] & B[0]) ^ (A[1] & B[4]) ^ (A[2] & B[3]) ^ (A[3] & B[2]) ^ (A[4] & B[1]) ^ (A[3] & B[4]) ^ (A[4] & B[3]) ^ (A[4] & B[4]);
assign Y[1] = (A[0] & B[1]) ^ (A[1] & B[0]) ^ (A[2] & B[4]) ^ (A[3] & B[3]) ^ (A[4] & B[2]);
assign Y[0] = (A[0] & B[0])	^ (A[1] & B[4]) ^ (A[2] & B[3]) ^ (A[3] & B[2]) ^ (A[4] & B[1]) ^ (A[4] & B[4]);

endmodule
