//-----------------------------------------------
//
// Title       : D_reg
// Design      : RS_encoder
// Author      : Sindre
// File        : D_reg.v
//
//-----------------------------------------------
//
// Description : D-Register, negative edge reset
//
//-----------------------------------------------
`timescale 1 ns / 1 ps

//{module {D_reg}}
module D_reg(clk, reset, enable, d_in, d_out);
	
input clk;
input reset;
input enable;
input [4:0] d_in;

wire clk;
wire reset;
wire enable;
wire [4:0] d_in;

output [4:0] d_out;
reg [4:0] d_out;

always @ (posedge clk or negedge reset)
begin
	if(!reset)begin
		d_out <= 5'b0000;
	end	else if(enable)begin
		d_out <= d_in;
	end
end	
endmodule