//--------------------------------------------------------
//
// Title       : MUX
// Design      : Encoder
// Author      : Sindre
// File        : MUX.v
//
//--------------------------------------------------------
//
// Description : two input one output  5 bit multiplexer
//
//--------------------------------------------------------
`timescale 1 ns / 1 ps

//{module {MUX}}
module MUX (in1, in2, sel, out1);
	
	input [4:0] in1;
	input [4:0] in2;
	input sel;
	
	wire [4:0] in1;
	wire [4:0] in2;
	wire sel;
	
	output [4:0] out1;
	
	reg [4:0] out1;
	
	always @(in1 or in2 or sel)
	begin
		if(sel)
			out1 = in2;
		else
			out1 = in1;
	end
endmodule